String publishDate,itemType;
int bib, checkOutCount, adoption, age, relative_age, publishOrder;
String minCheckOut, maxCheckOut, title;
float fullFrequency, partialFrequency;


class DataPoint{
  
  String publishDate,itemType;
  int bib, checkOutCount, adoption, age, relative_age, publishOrder;
  String minCheckOut, maxCheckOut, title;
  float fullFrequency, partialFrequency, easing;
  
  int id;
  float x, y, h=2, w=2;
  color c;
  
  DataPoint(int nid, String nitemType, int ncheckOutCount, int nadoption, int nage, int nrelative_age, float nfullFrequency, float npartialFrequency, int nPublishOrder, String ntitle){
    id = nid;
    itemType = nitemType;
    checkOutCount = ncheckOutCount;
    adoption = nadoption;
    age = nage;
    relative_age = nrelative_age;
    fullFrequency = nfullFrequency;
    partialFrequency = npartialFrequency;
    publishOrder = nPublishOrder;
    title = ntitle;
    easing = 0.05;
  }
  
  //void setX(){ x = adoption; }
  //void setY(){ y = fullFrequency; }
  void setPosition(float new_x, float new_y){
    x += (new_x - x) * easing;
    y += (new_y - y) * easing;
  }
  
  void setColor(int i, String colorToggle){
    c = colorScheme(i, colorToggle);
  }
  
  void display(){
    //colorMode(HSB, 100);
    fill(c);
    noStroke();
    rect(x, y, w, h);
  }
  
  void displayLabel(){
    textAlign(CENTER, CENTER);
    textSize(8);
    fill(255);
    text(title, x-10, y-10);
  }
  
  void highlight(){
    c = color(255,255,255,1);
  }

}